[ARVADOS-DEV] updated: 73b46d8b02451bb782f7262253778593181fd02d

git at public.curoverse.com git at public.curoverse.com
Mon Sep 22 09:35:58 EDT 2014


Summary of changes:
 jenkins/run-tests.sh | 161 +++++++++++++++++++++++++++------------------------
 1 file changed, 85 insertions(+), 76 deletions(-)

       via  73b46d8b02451bb782f7262253778593181fd02d (commit)
       via  1b30b40e3b83876ef1d96bcbffb9356dce94c5b7 (commit)
      from  0f9882d559fc996a260fb6e00254fd9d5f7de218 (commit)

Those revisions listed above that are new to this repository have
not appeared on any other notification email; so we list those
revisions in full, below.


commit 73b46d8b02451bb782f7262253778593181fd02d
Author: Tom Clegg <tom at curoverse.com>
Date:   Fri Sep 19 23:39:11 2014 -0400

    3894: Use $GEMHOME tmpdir instead of user's $HOME for userspace gem installs.

diff --git a/jenkins/run-tests.sh b/jenkins/run-tests.sh
index 852bd43..680ae0a 100755
--- a/jenkins/run-tests.sh
+++ b/jenkins/run-tests.sh
@@ -45,12 +45,16 @@ EOF
 # environment that could interfere with the tests.
 unset $(env | cut -d= -f1 | grep \^ARVADOS_)
 
-COLUMNS=80
-
+# Reset other variables that could affect our [tests'] behavior by
+# accident.
 GITDIR=
 GOPATH=
 VENVDIR=
 PYTHONPATH=
+GEMHOME=
+
+COLUMNS=80
+
 cli_test=
 workbench_test=
 apiserver_test=
@@ -68,7 +72,7 @@ fi
 declare -A leave_temp
 clear_temp() {
     leaving=""
-    for var in VENVDIR GOPATH GITDIR
+    for var in VENVDIR GOPATH GITDIR GEMHOME
     do
         if [[ -z "${leave_temp[$var]}" ]]
         then
@@ -101,15 +105,15 @@ while [[ -n "$1" ]]
 do
     arg="$1"; shift
     case "$arg" in
-        --skip)
-            skipwhat="$1"; shift
-            skip[$skipwhat]=1
-            ;;
         --help)
             echo >&2 "$helpmessage"
             echo >&2
             exit 1
             ;;
+        --skip)
+            skipwhat="$1"; shift
+            skip[$skipwhat]=1
+            ;;
         --only)
             only="$1"; shift
             ;;
@@ -119,6 +123,7 @@ do
         --leave-temp)
             leave_temp[VENVDIR]=1
             leave_temp[GOPATH]=1
+            leave_temp[GEMHOME]=1
             ;;
         *=*)
             eval $(echo $arg | cut -d= -f1)=\"$(echo $arg | cut -d= -f2-)\"
@@ -142,16 +147,15 @@ if [[ -n "$CONFIGSRC" ]]; then
 fi
 
 # Set up temporary install dirs (unless existing dirs were supplied)
-if [[ -n "$VENVDIR" ]]; then
-    leave_temp[VENVDIR]=1
-else
-    VENVDIR=$(mktemp -d)
-fi
-if [[ -n "$GOPATH" ]]; then
-    leave_temp[GOPATH]=1
-else
-    GOPATH=$(mktemp -d)
-fi
+for tmpdir in VENVDIR GOPATH GEMHOME
+do
+    if [[ -n "${!tmpdir}" ]]; then
+        leave_temp[$tmpdir]=1
+    else
+        eval $tmpdir=$(mktemp -d)
+    fi
+done
+PATH="$GEMHOME/.gem/ruby/2.1.0/bin:$PATH"
 export GOPATH
 mkdir -p "$GOPATH/src/git.curoverse.com"
 ln -sfn "$WORKSPACE" "$GOPATH/src/git.curoverse.com/arvados.git" \
@@ -220,26 +224,28 @@ title () {
 
 install_docs() {
     cd "$WORKSPACE/doc"
-    bundle install --no-deployment
+    HOME="$GEMHOME" bundle install --no-deployment
     rm -rf .site
     # Make sure python-epydoc is installed or the next line won't do much good!
     ARVADOS_API_HOST=qr1hi.arvadosapi.com
-    PYTHONPATH=$WORKSPACE/sdk/python/ bundle exec rake generate baseurl=file://$WORKSPACE/doc/.site/ arvados_workbench_host=workbench.$ARVADOS_API_HOST arvados_api_host=$ARVADOS_API_HOST
+    PYTHONPATH=$WORKSPACE/sdk/python/ HOME="$GEMHOME" bundle exec rake generate baseurl=file://$WORKSPACE/doc/.site/ arvados_workbench_host=workbench.$ARVADOS_API_HOST arvados_api_host=$ARVADOS_API_HOST
     unset ARVADOS_API_HOST
 }
 do_install docs
 
 install_ruby_sdk() {
     cd "$WORKSPACE/sdk/ruby" \
+        && HOME="$GEMHOME" bundle install --no-deployment \
         && gem build arvados.gemspec \
-        && gem install --user-install --no-ri --no-rdoc `ls -t arvados-*.gem|head -n1`
+        && HOME="$GEMHOME" gem install --user-install --no-ri --no-rdoc `ls -t arvados-*.gem|head -n1`
 }
 do_install ruby_sdk
 
 install_cli() {
     cd "$WORKSPACE/sdk/cli" \
+        && HOME="$GEMHOME" bundle install --no-deployment \
         && gem build arvados-cli.gemspec \
-        && gem install --user-install --no-ri --no-rdoc `ls -t arvados-cli-*.gem|head -n1`
+        && HOME="$GEMHOME" gem install --user-install --no-ri --no-rdoc `ls -t arvados-cli-*.gem|head -n1`
 }
 do_install cli
 
@@ -265,7 +271,8 @@ do_install fuse
 
 install_apiserver() {
     cd "$WORKSPACE/services/api"
-    bundle install --no-deployment
+    export RAILS_ENV=test
+    HOME="$GEMHOME" bundle install --no-deployment
 
     rm -f config/environments/test.rb
     cp config/environments/test.rb.example config/environments/test.rb
@@ -285,8 +292,6 @@ install_apiserver() {
     sed -i'' -e "s:SECRET_TOKEN:$SECRET_TOKEN:" config/application.yml
     sed -i'' -e "s:BLOB_SIGNING_KEY:$BLOB_SIGNING_KEY:" config/application.yml
 
-    export RAILS_ENV=test
-
     # Set up empty git repo (for git tests)
     GITDIR=$(mktemp -d)
     sed -i'' -e "s:/var/cache/git:$GITDIR:" config/application.default.yml
@@ -306,9 +311,9 @@ install_apiserver() {
     psql arvados_test -c "SELECT pg_terminate_backend (pg_stat_activity.procpid::int) FROM pg_stat_activity WHERE pg_stat_activity.datname = 'arvados_test';" 2>/dev/null
 
     cd "$WORKSPACE/services/api" \
-        && bundle exec rake db:drop \
-        && bundle exec rake db:create \
-        && bundle exec rake db:setup
+        && HOME="$GEMHOME" bundle exec rake db:drop \
+        && HOME="$GEMHOME" bundle exec rake db:create \
+        && HOME="$GEMHOME" bundle exec rake db:setup
 }
 do_install apiserver
 
@@ -327,29 +332,29 @@ done
 
 test_doclinkchecker() {
     cd "$WORKSPACE/doc"
-    bundle exec rake linkchecker baseurl=file://$WORKSPACE/doc/.site/
+    HOME="$GEMHOME" bundle exec rake linkchecker baseurl=file://$WORKSPACE/doc/.site/
 }
 do_test doclinkchecker
 
 test_ruby_sdk() {
     cd "$WORKSPACE/sdk/ruby" \
-        && bundle install --no-deployment \
-        && bundle exec rake test
+        && HOME="$GEMHOME" bundle install --no-deployment \
+        && HOME="$GEMHOME" bundle exec rake test
 }
 do_test ruby_sdk
 
 test_cli() {
     title "Starting SDK CLI tests"
     cd "$WORKSPACE/sdk/cli" \
-        && bundle install --no-deployment \
+        && HOME="$GEMHOME" bundle install --no-deployment \
         && mkdir -p /tmp/keep \
-        && KEEP_LOCAL_STORE=/tmp/keep bundle exec rake test $cli_test
+        && KEEP_LOCAL_STORE=/tmp/keep HOME="$GEMHOME" bundle exec rake test $cli_test
 }
 do_test cli
 
 test_apiserver() {
     cd "$WORKSPACE/services/api"
-    bundle exec rake test $apiserver_test
+    HOME="$GEMHOME" bundle exec rake test $apiserver_test
 }
 do_test apiserver
 
@@ -385,8 +390,8 @@ done
 
 test_workbench() {
     cd "$WORKSPACE/apps/workbench" \
-        && bundle install --no-deployment \
-        && bundle exec rake test $workbench_test
+        && HOME="$GEMHOME" bundle install --no-deployment \
+        && HOME="$GEMHOME" bundle exec rake test $workbench_test
 }
 do_test workbench
 

commit 1b30b40e3b83876ef1d96bcbffb9356dce94c5b7
Author: Tom Clegg <tom at curoverse.com>
Date:   Fri Sep 19 23:35:30 2014 -0400

    3894: Add --help message.

diff --git a/jenkins/run-tests.sh b/jenkins/run-tests.sh
index 9fe3218..852bd43 100755
--- a/jenkins/run-tests.sh
+++ b/jenkins/run-tests.sh
@@ -1,49 +1,48 @@
 #!/bin/bash
 
-# Install and test Arvados components.
-#
-# Exit non-zero if any tests fail.
-#
-# Arguments:
-# --skip FOO     Do not test the FOO component.
-# --only FOO     Do not test anything except the FOO component.
-# WORKSPACE=path Arvados source tree to test.
-# CONFIGSRC=path Dir with api server config files to copy into source tree.
-# envvar=value   Set $envvar to value
-#
-# Regardless of which components are tested, install all components in
-# the usual sequence. (Many test suites depend on other components
-# being installed.)
-#
-# To run a specific Ruby test, set $workbench_test, $apiserver_test or
-# $cli_test on the command line:
-#
-# $ run-tests.sh --only workbench workbench_test=TEST=test/integration/pipeline_instances_test.rb
-#
-#
-# To run a specific Python test set $python_sdk_test or $fuse_test.
-#
-# $ run-tests.sh --only python_sdk python_sdk_test="--test-suite tests.test_keep_locator"
-#
-#
-# You can also pass "export ARVADOS_DEBUG=1" to enable additional debugging output:
-#
-# $ run-tests.sh "export ARVADOS_DEBUG=1"
-#
-#
-# Finally, you can skip the installation steps on subsequent runs this way:
-#
-## First run
-# $ run-tests.sh --leave-temp
-#
-## Subsequent runs: record the values of VENVDIR and GOPATH from the first run, and
-# provide them on the command line in subsequent runs:
-#
-# $ run-tests.sh --skip-install VENVDIR="/tmp/tmp.y3tsTmigio" GOPATH="/tmp/tmp.3r4sSA9F3l"
-
-
-# First make sure to remove any ARVADOS_ variables from the calling environment
-# that could interfer with the tests.
+read -rd "\000" helpmessage <<EOF
+$(basename $0): Install and test Arvados components.
+
+Exit non-zero if any tests fail.
+
+Syntax:
+        $(basename $0) WORKSPACE=/path/to/arvados [options]
+
+Options:
+
+--skip FOO     Do not test the FOO component.
+--only FOO     Do not test anything except the FOO component.
+--leave-temp   Do not remove GOPATH, virtualenv, and other temp dirs at exit.
+               Instead, show which directories were used this time so they
+               can be reused in subsequent invocations.
+--skip-install Do not run any install steps. Just run tests.
+               You should provide GOPATH, GEMHOME, and VENVDIR options
+               from a previous invocation if you use this option.
+WORKSPACE=path Arvados source tree to test.
+CONFIGSRC=path Dir with api server config files to copy into source tree.
+apiserver_test="TEST=test/functional/arvados/v1/collections_test.rb"
+               Restrict apiserver tests to the given file
+python_sdk_test="--test-suite test.test_keep_locator"
+               Restrict Python SDK tests to the given class
+workbench_test="TEST=test/integration/pipeline_instances_test.rb"
+               Restrict Workbench tests to the given file
+ARVADOS_DEBUG=1
+               Print more debug messages
+envvar=value   Set \$envvar to value. Primarily useful for WORKSPACE,
+               *_test, and other examples shown above.
+
+Assuming --skip-install is not given, all components are installed
+into \$GOPATH, \$VENDIR, and \$GEMHOME before running any tests. Many
+test suites depend on other components being installed, and installing
+everything tends to be quicker than debugging dependencies.
+
+More information and background:
+
+https://arvados.org/projects/arvados/wiki/Running_tests
+EOF
+
+# First make sure to remove any ARVADOS_ variables from the calling
+# environment that could interfere with the tests.
 unset $(env | cut -d= -f1 | grep \^ARVADOS_)
 
 COLUMNS=80
@@ -106,6 +105,11 @@ do
             skipwhat="$1"; shift
             skip[$skipwhat]=1
             ;;
+        --help)
+            echo >&2 "$helpmessage"
+            echo >&2
+            exit 1
+            ;;
         --only)
             only="$1"; shift
             ;;
@@ -120,7 +124,7 @@ do
             eval $(echo $arg | cut -d= -f1)=\"$(echo $arg | cut -d= -f2-)\"
             ;;
         *)
-            echo >&2 "$0: Unrecognized option: '$arg'"
+            echo >&2 "$0: Unrecognized option: '$arg'. Try: $0 --help"
             exit 1
             ;;
     esac

-----------------------------------------------------------------------


hooks/post-receive
-- 




More information about the arvados-commits mailing list